//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                               i-PSI@MA Signal.mq4 |
//|                                       Copyright  2012, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|    07.11.2012      bs-PSI@MAMs.mqh             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define       BULL          0
#define       BEAR          1
#define       STOP         -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color2 LightSeaGreen // UP
#property indicator_width2 2
#property indicator_color3 Magenta       // DW
#property indicator_width3 2
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
/*extern*/ bool   IsVisualControl          = TRUE;            //    
extern int    SignalOnBar              = 1;                //    ( )  
extern int    VerificationBars         = 2;                //      
extern int    Deviation                = 3;                //      .
//IIIIIIIIIIIIIIIIIII============= =============IIIIIIIIIIIIIIIIIIIIII+
double        Buf_DW[],                                    // Down trend bars
              Buf_UP[],                                    // Up trend bars
              Buf_Signal[],                                // Signal
              bd_SymPoint, bd_Deviation;
int           bi_Decimal, bi_SymDigits;
string        bs_Error = "";
bool          bb_VisualControl = false, bb_ControlBeginChangeTrend;
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
#include      <bs-PSI@MAMs.mqh>                           //    CCI
#include      <stderror.mqh>                               //   
//|***********************************************************************************|
#import "stdlib.ex4"                                       //   
    string ErrorDescription (int error_code);
                                     //   
#import
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom indicator initialization function                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{  
//----
    bi_SymDigits = Digits;
    //----   
    if (bi_SymDigits % 2 == 1) {bi_Decimal = 10;} else {bi_Decimal = 1;}
    bd_SymPoint = fGet_Point (Symbol());
    Deviation *= bi_Decimal;
    bd_Deviation = Deviation * bd_SymPoint;
    SetIndexStyle (0, DRAW_NONE);
    SetIndexBuffer (0, Buf_Signal);
    SetIndexLabel (0, "Signal");
    SetIndexEmptyValue (0, STOP);
    SetIndexStyle (1, DRAW_ARROW);
    SetIndexBuffer (1, Buf_UP);
    SetIndexLabel (1, "UP");
    SetIndexDrawBegin (1, MA_Period * MA_K_Period);
    SetIndexArrow (1, 236);
    SetIndexStyle (2, DRAW_ARROW);
    SetIndexBuffer (2, Buf_DW);
    SetIndexLabel (2, "DN");
    SetIndexDrawBegin (2, MA_Period * MA_K_Period);
    SetIndexArrow (2, 238);
    //----     
    bia_PeriodMA[0] = MA_Period;
    bia_PeriodMA[1] = MA_Period * MA_K_Period;
    bb_VisualControl = IsVisualControl;
    bb_ControlBeginChangeTrend = (Use_ChangeTrend.MA > 0);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor indicator deinitialization function                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    //----     
    fObjectsDeleteAll ("MA_", -1, -1);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom indicator iteration function                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{  
    int li_CountedBars = IndicatorCounted();
//----
    if (li_CountedBars < 0) return (-1);
    if (li_CountedBars > 0) li_CountedBars--;
    int li_Signal, li_Limit = Bars - 1 - li_CountedBars;
    if (li_Limit < 0) return (-1);
    //----  Limit  1,    
    if (li_Limit > 2) li_Limit = Bars - 1;
    if (li_CountedBars < li_Limit)
    {
        SetIndexEmptyValue (0, STOP);
        SetIndexEmptyValue (1, EMPTY_VALUE);
        SetIndexEmptyValue (2, EMPTY_VALUE);
    }
    for (int li_Bar = li_Limit; li_Bar >= 0; li_Bar--)
    {
        li_Signal = fGet_SignalMA (Symbol(), Period(), bd_Deviation, bb_ControlBeginChangeTrend, li_Bar, VerificationBars);
        if (li_Signal == STOP) {Buf_Signal[li_Bar] = Buf_Signal[li_Bar+1]; continue;}
        if (li_Signal == BULL)
        {
            Buf_UP[li_Bar] = Low[li_Bar];
            Buf_Signal[li_Bar] = BULL;
        }
        else if (li_Signal == BEAR)
        {
            Buf_DW[li_Bar] = High[li_Bar];
            Buf_Signal[li_Bar] = BEAR;
        }
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      : TarasBY, taras_bulba@tut.by                                           |
//+-----------------------------------------------------------------------------------+
//|     : 23.07.2011                                                            |
//|   :   OBJ_ARROW                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_Arrow (string fs_Name,         //  
                 int fi_ArrowCode,       //    OBJ_ARROW
                 string fs_Description,  //  
                 int fi_Size = 0,        //  
                 color fc_Color = Gold,  // 
                 datetime fdt_Time = 0,  //  
                 double fd_Price = 0,    //  
                 int fi_Window = 0)      //  
{
	 int err = GetLastError();
//----
    //fSet_Arrow (ls_Name, 218, "", 2, Gold, Time[0], Bid, 0);
    if (fs_Name == "") fs_Name = TimeToStr (Time[0]);
    if (!fObjectFind (fs_Name)) {if (!ObjectCreate (fs_Name, OBJ_ARROW, fi_Window, 0, 0)) return (false);}
    if (fdt_Time == 0) {fdt_Time = Time[0];}
    if (fd_Price == 0) {fd_Price = Bid;}
    ObjectSet (fs_Name, OBJPROP_TIME1, fdt_Time);
    ObjectSet (fs_Name, OBJPROP_PRICE1, fd_Price);
    ObjectSet (fs_Name, OBJPROP_ARROWCODE, fi_ArrowCode);
    if (fs_Description != "") ObjectSetText (fs_Name, fs_Description, 10, "Calibri", fc_Color);
    ObjectSet (fs_Name, OBJPROP_COLOR, fc_Color);
    ObjectSet (fs_Name, OBJPROP_WIDTH, fi_Size);
    //----   
    fGet_LastError (bs_Error, "fSet_Arrow()");
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      : TarasBY, taras_bulba@tut.by                                           |
//+-----------------------------------------------------------------------------------+
//|     : 02.10.2012                                                            |
//|   :     OBJ_ARROW                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_SignalAtArrow (string fs_Name,         //  
                         int fi_ArrowCode,       //    OBJ_ARROW
                         string fs_Description,  //  
                         int fi_Size = 0,        //  
                         color fc_Color = Gold,  // 
                         datetime fdt_Time = 0,  //  
                         double fd_Price = 0,    //  
                         int fi_Window = 0)      //  
{
    if (fi_Window < 0) return (false);
    static datetime ldt_NewBar = 0;
    static string   ls_Name = "";
    datetime ldt_BeginBar = fdt_Time;
//----
    if (ldt_NewBar != ldt_BeginBar || ls_Name != fs_Name)
    {
        ldt_NewBar = ldt_BeginBar;
        ls_Name = fs_Name;
        return (fSet_Arrow (StringConcatenate (fs_Name, TimeToStr (fdt_Time)), fi_ArrowCode, fs_Description, fi_Size, fc_Color, fdt_Time, fd_Price, fi_Window));
    }
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fObjectFind (string fs_Name)
{
    if (StringLen (fs_Name) == 0) {return (false);}
    if (ObjectFind (fs_Name) != -1) {return (true);}
//----
    string ls_Name = "";
    int err = GetLastError();
//----
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        ls_Name = ObjectName (i);
        if (ls_Name == fs_Name) {return (true);}
    }
    //----   
    fGet_LastError (bs_Error, StringConcatenate ("fObjectFind(): Find (", fs_Name, ")"));
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fObjectsDeleteAll  (string fs_Pref = "",     //   
                         int fi_Window = -1,      //  
                         int ti_Type = -1)        //  
                         
{
    string ls_Name; 
//----
	 for (int li_OBJ = ObjectsTotal() - 1; li_OBJ >= 0; li_OBJ--)
	 {
        ls_Name = ObjectName (li_OBJ);
        //----  " " 
        if (fi_Window >= 0) {if (ObjectFind (ls_Name) != fi_Window) continue;}
        //----  " "  
		  if (ti_Type >= 0) {if (ObjectType (ls_Name) != ti_Type) continue;}
		  if (fs_Pref != "") {if (StringFind (ls_Name, fs_Pref) != 0) continue;}
		  ObjectDelete (ls_Name);
	 }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_LastError (string& Comm_Error, string Com = "")
{
    int err = GetLastError();
//---- 
    if (err > 0)
    {
        Comm_Error = StringConcatenate (Com, ":   ", err, " :: ", ErrorDescription (err));
        Print (Comm_Error);
    }
//---- 
    return (err);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                               |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           fi_Bar                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_PriceOnBar (int fi_VariantPrice,    //  
                        string fs_Symbol,       // Symbol
                        int fi_TF,              // 
                        int fi_Bar = 1)         // 
{
    double ld_Price = 0.0;
//----
    switch (fi_VariantPrice)
    {
        case 0:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = Close[fi_Bar]; break;}
            ld_Price = iClose (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 1:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = Open[fi_Bar]; break;}
            ld_Price = iOpen (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 2:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = High[fi_Bar]; break;}
            ld_Price = iHigh (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 3:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = Low[fi_Bar]; break;}
            ld_Price = iLow (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 4: //  , (high+low)/2
            if (fs_Symbol == Symbol()) if (fi_TF == Period())
            {ld_Price = (High[fi_Bar] + Low[fi_Bar]) / 2; break;}
            ld_Price = (iHigh (fs_Symbol, fi_TF, fi_Bar) + iLow (fs_Symbol, fi_TF, fi_Bar)) / 2;
            break;
        case 5: //  , (high+low+close)/3
            if (fs_Symbol == Symbol()) if (fi_TF == Period())
            {ld_Price = (High[fi_Bar] + Low[fi_Bar] + Close[fi_Bar]) / 3; break;}
            ld_Price = (iHigh (fs_Symbol, fi_TF, fi_Bar) + iLow (fs_Symbol, fi_TF, fi_Bar) + iClose (fs_Symbol, fi_TF, fi_Bar)) / 3;
            break;
        case 6: //   , (high+low+close+close)/4
            if (fs_Symbol == Symbol()) if (fi_TF == Period())
            {ld_Price = (High[fi_Bar] + Low[fi_Bar] + 2 * Close[fi_Bar]) / 4; break;}
            ld_Price = (iHigh (fs_Symbol, fi_TF, fi_Bar) + iLow (fs_Symbol, fi_TF, fi_Bar) + 2 * iClose (fs_Symbol, fi_TF, fi_Bar)) / 4;
            break;
    }
//----
    return (ld_Price);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|        ,   Point                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_Point (string fs_Symbol = "")
{
    double ld_Point = 0.0;
//----
    if (fs_Symbol == "") {fs_Symbol = Symbol();}
    if (fs_Symbol == Symbol()) ld_Point = Point;
    else ld_Point = MarketInfo (fs_Symbol, MODE_POINT);
    //----   
    if (ld_Point == 0.0)
    {
        if (fs_Symbol == Symbol()) int li_Digits = Digits;
        else li_Digits = MarketInfo (fs_Symbol, MODE_DIGITS);
        if (li_Digits > 0) {ld_Point = 1.0 / MathPow (10, li_Digits);}
    }
    else {return (ld_Point);}
//----
    return (ld_Point);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_NameOP (int fi_Type) 
{
//----
    switch (fi_Type) 
    {
        case -2          : return ("trading");
        case -1          : return ("ALL");
        case OP_BUY      : return ("BUY");
        case OP_SELL     : return ("SELL");
        case OP_BUYLIMIT : return ("BUYLIMIT");
        case OP_SELLLIMIT: return ("SELLLIMIT");
        case OP_BUYSTOP  : return ("BUYSTOP");
        case OP_SELLSTOP : return ("SELLSTOP");
        case 6           : if (OrderType() == 6) return ("balance"); else return ("UNI");
        case 7           : return ("pending");
    }
    return (StringConcatenate ("None (", fi_Type, ")"));
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           double  Digits                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double NDD (double v) {return (NormalizeDouble (v, bi_SymDigits));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

